"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var typeorm_1 = require("typeorm");
var basicR_type_1 = require("../basicR.type");
var class_validator_1 = require("class-validator");
var user_type_1 = require("./user.type");
var ActionType;
(function (ActionType) {
    // ALL
    ActionType["ALL"] = "ALL";
    // DAIRIES
    ActionType["EDIT_DAIRIES"] = "EDIT_DAIRIES";
    ActionType["EXCLUDE_DAIRIES"] = "EXCLUDE_DAIRIES";
    ActionType["EDIT_CONTRACTS"] = "EDIT_CONTRACTS";
    // CONSULTANT
    ActionType["EDIT_CONSULTANTS"] = "EDIT_CONSULTANTS";
    ActionType["ASSOCIATE_PROPERTIES"] = "ASSOCIATE_PROPERTIES";
    ActionType["EXCLUDE_CONSULTANTS"] = "EXCLUDE_CONSULTANTS";
    // VISITS
    ActionType["EDIT_VISITS"] = "EDIT_VISITS";
    ActionType["EDIT_EXTRA_VISITS"] = "EDIT_EXTRA_VISITS";
    ActionType["EXCLUDE_VISITS"] = "EXCLUDE_VISITS";
    // PROPERTIES / FARMERS
    ActionType["EDIT_FARMERS"] = "EDIT_FARMERS";
    ActionType["EDIT_PROPERTIES"] = "EDIT_PROPERTIES";
    ActionType["EDIT_AGREEMENTS"] = "EDIT_AGREEMENTS";
    ActionType["EXCLUDE_PROPERTIES"] = "EXCLUDE_PROPERTIES";
    // ADMIN
    ActionType["EDIT_ADMS"] = "EDIT_ADMS";
    ActionType["EXCLUDE_ADMS"] = "EXCLUDE_ADMS";
    ActionType["EDIT_PERMISSIONS"] = "EDIT_PERMISSIONS";
    ActionType["EXCLUDE_PERMISSIONS"] = "EXCLUDE_PERMISSIONS";
    // OTHERS
    ActionType["VIEW_NOTIFICATIONS"] = "VIEW_NOTIFICATIONS";
    ActionType["VIEW_MAPS"] = "VIEW_MAPS";
    ActionType["VIEW_DASHBOARDS"] = "VIEW_DASHBOARDS";
    ActionType["VIEW_INDICATORS"] = "VIEW_INDICATORS";
    // ...
})(ActionType = exports.ActionType || (exports.ActionType = {}));
var Permission = /** @class */ (function (_super) {
    __extends(Permission, _super);
    function Permission() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        class_validator_1.IsString(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", String)
    ], Permission.prototype, "name", void 0);
    __decorate([
        class_validator_1.IsString(),
        typeorm_1.Column({ nullable: false, default: ActionType.ALL + "," + ActionType.EDIT_DAIRIES }),
        __metadata("design:type", String)
    ], Permission.prototype, "actions", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.ManyToMany(function (type) { return user_type_1.User; }, function (user) { return user.permissions; }, { nullable: true }),
        __metadata("design:type", Array)
    ], Permission.prototype, "users", void 0);
    Permission = __decorate([
        typeorm_1.Entity()
    ], Permission);
    return Permission;
}(basicR_type_1.BasicREntity));
exports.Permission = Permission;
//# sourceMappingURL=permission.type.js.map