"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var address_type_1 = require("./address.type");
var typeorm_1 = require("typeorm");
var basicR_type_1 = require("../basicR.type");
var class_validator_1 = require("class-validator");
var permission_type_1 = require("./permission.type");
var userFarmer_type_1 = require("../visit/userFarmer.type");
var userConsultant_type_1 = require("../visit/userConsultant.type");
var User = /** @class */ (function (_super) {
    __extends(User, _super);
    function User() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        class_validator_1.IsString(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", String)
    ], User.prototype, "name", void 0);
    __decorate([
        class_validator_1.IsString(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", String)
    ], User.prototype, "email", void 0);
    __decorate([
        class_validator_1.IsString(),
        class_validator_1.IsOptional(),
        typeorm_1.Column({ nullable: true }),
        __metadata("design:type", String)
    ], User.prototype, "linkPhoto", void 0);
    __decorate([
        class_validator_1.IsString(),
        class_validator_1.IsOptional(),
        typeorm_1.Column({ nullable: true }),
        __metadata("design:type", String)
    ], User.prototype, "phones", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.OneToOne(function (type) { return address_type_1.Address; }, { cascade: true, nullable: true }),
        typeorm_1.JoinColumn(),
        __metadata("design:type", address_type_1.Address)
    ], User.prototype, "address", void 0);
    __decorate([
        class_validator_1.IsBoolean(),
        class_validator_1.IsOptional(),
        typeorm_1.Column({ nullable: false, default: false }),
        __metadata("design:type", Boolean)
    ], User.prototype, "relog", void 0);
    __decorate([
        class_validator_1.IsBoolean(),
        class_validator_1.IsOptional(),
        typeorm_1.Column({ nullable: false, default: true }),
        __metadata("design:type", Boolean)
    ], User.prototype, "tutorial", void 0);
    __decorate([
        class_validator_1.IsString(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", String)
    ], User.prototype, "password", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.OneToMany(function (type) { return userFarmer_type_1.UserFarmer; }, function (userFarmer) { return userFarmer.user; }, { nullable: true }),
        __metadata("design:type", Array)
    ], User.prototype, "userFarmer", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.OneToMany(function (type) { return userConsultant_type_1.UserConsultant; }, function (userConsultant) { return userConsultant.user; }, { nullable: true }),
        __metadata("design:type", Array)
    ], User.prototype, "userConsultant", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.ManyToMany(function (type) { return permission_type_1.Permission; }, function (permission) { return permission.users; }, { nullable: true }),
        typeorm_1.JoinTable({ name: 'user_permission' }),
        __metadata("design:type", Array)
    ], User.prototype, "permissions", void 0);
    User = __decorate([
        typeorm_1.Entity()
    ], User);
    return User;
}(basicR_type_1.BasicREntity));
exports.User = User;
//# sourceMappingURL=user.type.js.map