"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var class_validator_1 = require("class-validator");
var typeorm_1 = require("typeorm");
var farm_type_1 = require("../visit/farm.type");
var basicR_type_1 = require("../basicR.type");
var loan_type_1 = require("./loan.type");
var RevenueCategory;
(function (RevenueCategory) {
    RevenueCategory[RevenueCategory["OTHER"] = 0] = "OTHER";
    RevenueCategory[RevenueCategory["MILK"] = 1] = "MILK";
    RevenueCategory[RevenueCategory["ANIMAL"] = 2] = "ANIMAL";
    RevenueCategory[RevenueCategory["MACHINERY"] = 3] = "MACHINERY";
    RevenueCategory[RevenueCategory["MANURE"] = 4] = "MANURE";
    RevenueCategory[RevenueCategory["PASTURE"] = 5] = "PASTURE";
    RevenueCategory[RevenueCategory["LOAN"] = 6] = "LOAN";
})(RevenueCategory = exports.RevenueCategory || (exports.RevenueCategory = {}));
var Revenue = /** @class */ (function (_super) {
    __extends(Revenue, _super);
    function Revenue() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        class_validator_1.IsDate(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", Date)
    ], Revenue.prototype, "date", void 0);
    __decorate([
        class_validator_1.IsNotEmpty(),
        typeorm_1.ManyToOne(function (type) { return farm_type_1.Farm; }, function (farm) { return farm.revenues; }, { nullable: false }),
        __metadata("design:type", farm_type_1.Farm)
    ], Revenue.prototype, "farm", void 0);
    __decorate([
        class_validator_1.IsBoolean(),
        typeorm_1.Column({ nullable: false, default: false }),
        __metadata("design:type", Boolean)
    ], Revenue.prototype, "sell", void 0);
    __decorate([
        class_validator_1.IsBoolean(),
        typeorm_1.Column({ nullable: false, default: false }),
        __metadata("design:type", Boolean)
    ], Revenue.prototype, "rent", void 0);
    __decorate([
        class_validator_1.IsNumber(),
        typeorm_1.Column({ nullable: false, type: 'int' }),
        __metadata("design:type", Number)
    ], Revenue.prototype, "category", void 0);
    __decorate([
        class_validator_1.IsNotEmpty(),
        typeorm_1.OneToMany(function (type) { return loan_type_1.Loan; }, function (loan) { return loan.revenue; }, { nullable: false }),
        __metadata("design:type", Array)
    ], Revenue.prototype, "loans", void 0);
    Revenue = __decorate([
        typeorm_1.Entity()
    ], Revenue);
    return Revenue;
}(basicR_type_1.BasicREntity));
exports.Revenue = Revenue;
//# sourceMappingURL=revenue.type.js.map