"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var dairyCompany_type_1 = require("./dairyCompany.type");
var typeorm_1 = require("typeorm");
var basicR_type_1 = require("../basicR.type");
var class_validator_1 = require("class-validator");
var farm_type_1 = require("./farm.type");
var contract_type_1 = require("./contract.type");
var visit_type_1 = require("./visit.type");
var TypeAgreement;
(function (TypeAgreement) {
    TypeAgreement[TypeAgreement["TYPE_1"] = 1] = "TYPE_1";
    TypeAgreement[TypeAgreement["TYPE_2"] = 2] = "TYPE_2"; // Industria de Laticinios
})(TypeAgreement = exports.TypeAgreement || (exports.TypeAgreement = {}));
var Agreement = /** @class */ (function (_super) {
    __extends(Agreement, _super);
    function Agreement() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        class_validator_1.IsDate(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", Date)
    ], Agreement.prototype, "endDate", void 0);
    __decorate([
        class_validator_1.IsDate(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", Date)
    ], Agreement.prototype, "initialDate", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsNumber(),
        typeorm_1.Column({ nullable: true }),
        __metadata("design:type", Number)
    ], Agreement.prototype, "acquiredMonthlyVisits", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.ManyToOne(function (type) { return dairyCompany_type_1.DairyCompany; }, function (dairyCompany) { return dairyCompany.agreements; }, { nullable: true }),
        __metadata("design:type", dairyCompany_type_1.DairyCompany)
    ], Agreement.prototype, "dairyCompany", void 0);
    __decorate([
        class_validator_1.IsNotEmpty(),
        typeorm_1.ManyToOne(function (type) { return farm_type_1.Farm; }, function (farm) { return farm.agreements; }, { nullable: false }),
        __metadata("design:type", farm_type_1.Farm)
    ], Agreement.prototype, "farm", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsArray(),
        typeorm_1.OneToMany(function (type) { return visit_type_1.Visit; }, function (visit) { return visit.agreement; }, { nullable: true }),
        __metadata("design:type", Array)
    ], Agreement.prototype, "visits", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.ManyToOne(function (type) { return contract_type_1.Contract; }, function (contract) { return contract.agreements; }, { nullable: true }),
        __metadata("design:type", contract_type_1.Contract)
    ], Agreement.prototype, "contract", void 0);
    Agreement = __decorate([
        typeorm_1.Entity()
    ], Agreement);
    return Agreement;
}(basicR_type_1.BasicREntity));
exports.Agreement = Agreement;
//# sourceMappingURL=agreement.type.js.map