"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var isBiggerThan_validator_1 = require("../../validators/isBiggerThan.validator");
var typeorm_1 = require("typeorm");
var basicR_type_1 = require("../basicR.type");
var class_validator_1 = require("class-validator");
var dairyCompany_type_1 = require("./dairyCompany.type");
var agreement_type_1 = require("./agreement.type");
var business_exception_1 = __importDefault(require("../../exceptions/business.exception"));
var TypeContract;
(function (TypeContract) {
    TypeContract[TypeContract["TYPE_1"] = 1] = "TYPE_1";
    TypeContract[TypeContract["TYPE_2"] = 2] = "TYPE_2"; // Programa Leite mais Saudável
})(TypeContract = exports.TypeContract || (exports.TypeContract = {}));
var DayTime;
(function (DayTime) {
    DayTime[DayTime["MORNING"] = 1] = "MORNING";
    DayTime[DayTime["EVENING"] = 2] = "EVENING";
    DayTime[DayTime["NIGHT"] = 3] = "NIGHT";
})(DayTime = exports.DayTime || (exports.DayTime = {}));
var Contract = /** @class */ (function (_super) {
    __extends(Contract, _super);
    function Contract() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        class_validator_1.IsNotEmpty(),
        typeorm_1.ManyToOne(function (type) { return dairyCompany_type_1.DairyCompany; }, function (dairyCompany) { return dairyCompany.contracts; }, { nullable: false }),
        __metadata("design:type", dairyCompany_type_1.DairyCompany)
    ], Contract.prototype, "dairyCompany", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsDate(),
        isBiggerThan_validator_1.IsBiggerThan("initialDate", { message: business_exception_1.default.CONTRACT.DATEBIGGER }),
        typeorm_1.Column({ nullable: true }),
        __metadata("design:type", Date)
    ], Contract.prototype, "endDate", void 0);
    __decorate([
        class_validator_1.IsDate(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", Date)
    ], Contract.prototype, "initialDate", void 0);
    __decorate([
        class_validator_1.IsString(),
        class_validator_1.IsOptional(),
        typeorm_1.Column({ nullable: true }),
        __metadata("design:type", String)
    ], Contract.prototype, "cancelReason", void 0);
    __decorate([
        class_validator_1.IsNumber(),
        class_validator_1.IsOptional(),
        typeorm_1.Column({ nullable: false, type: 'int' }),
        __metadata("design:type", Number)
    ], Contract.prototype, "dayTime", void 0);
    __decorate([
        class_validator_1.IsNumber(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false, type: 'int' }),
        __metadata("design:type", Number)
    ], Contract.prototype, "type", void 0);
    __decorate([
        class_validator_1.IsNumber(),
        typeorm_1.Column({ nullable: true, default: 0 }),
        __metadata("design:type", Number)
    ], Contract.prototype, "acquiredMonthlyVisits", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsArray(),
        typeorm_1.OneToMany(function (type) { return agreement_type_1.Agreement; }, function (agreement) { return agreement.contract; }, { nullable: true }),
        __metadata("design:type", Array)
    ], Contract.prototype, "agreements", void 0);
    Contract = __decorate([
        typeorm_1.Entity()
    ], Contract);
    return Contract;
}(basicR_type_1.BasicREntity));
exports.Contract = Contract;
//# sourceMappingURL=contract.type.js.map