"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var address_type_1 = require("../app/address.type");
var farm_type_1 = require("./farm.type");
var agreement_type_1 = require("./agreement.type");
var typeorm_1 = require("typeorm");
var basicR_type_1 = require("../basicR.type");
var class_validator_1 = require("class-validator");
var contract_type_1 = require("./contract.type");
var DairyCompany = /** @class */ (function (_super) {
    __extends(DairyCompany, _super);
    function DairyCompany() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        class_validator_1.IsString(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", String)
    ], DairyCompany.prototype, "name", void 0);
    __decorate([
        class_validator_1.IsString(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", String)
    ], DairyCompany.prototype, "companyName", void 0);
    __decorate([
        class_validator_1.IsString(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", String)
    ], DairyCompany.prototype, "identification", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsString(),
        typeorm_1.Column({ nullable: true }),
        __metadata("design:type", String)
    ], DairyCompany.prototype, "phones", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsString(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: true }),
        __metadata("design:type", String)
    ], DairyCompany.prototype, "emails", void 0);
    __decorate([
        class_validator_1.IsNotEmpty(),
        typeorm_1.OneToOne(function (type) { return address_type_1.Address; }, { cascade: true, nullable: false }),
        typeorm_1.JoinColumn(),
        __metadata("design:type", address_type_1.Address)
    ], DairyCompany.prototype, "address", void 0);
    __decorate([
        class_validator_1.IsNumber(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", Number)
    ], DairyCompany.prototype, "payDay", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsArray(),
        typeorm_1.OneToMany(function (type) { return farm_type_1.Farm; }, function (farm) { return farm.dairyCompany; }, { nullable: true }),
        __metadata("design:type", Array)
    ], DairyCompany.prototype, "farms", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsArray(),
        typeorm_1.OneToMany(function (type) { return contract_type_1.Contract; }, function (contract) { return contract.dairyCompany; }, { nullable: true }),
        __metadata("design:type", Array)
    ], DairyCompany.prototype, "contracts", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsArray(),
        typeorm_1.OneToMany(function (type) { return agreement_type_1.Agreement; }, function (agreement) { return agreement.dairyCompany; }, { nullable: true }),
        __metadata("design:type", Array)
    ], DairyCompany.prototype, "agreements", void 0);
    DairyCompany = __decorate([
        typeorm_1.Entity()
    ], DairyCompany);
    return DairyCompany;
}(basicR_type_1.BasicREntity));
exports.DairyCompany = DairyCompany;
//# sourceMappingURL=dairyCompany.type.js.map