"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var userConsultant_type_1 = require("./userConsultant.type");
var userFarmer_type_1 = require("./userFarmer.type");
var inventoryItem_type_1 = require("./../financial/inventory/inventoryItem.type");
var animal_type_1 = require("./../zootechnical/animal.type");
var expense_type_1 = require("./../financial/expense.type");
var address_type_1 = require("../app/address.type");
var dairyCompany_type_1 = require("./dairyCompany.type");
var typeorm_1 = require("typeorm");
var basicR_type_1 = require("../basicR.type");
var class_validator_1 = require("class-validator");
var agreement_type_1 = require("./agreement.type");
var revenue_type_1 = require("../financial/revenue.type");
var Farm = /** @class */ (function (_super) {
    __extends(Farm, _super);
    function Farm() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        class_validator_1.IsString(),
        class_validator_1.IsNotEmpty(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", String)
    ], Farm.prototype, "name", void 0);
    __decorate([
        class_validator_1.IsDefined(),
        typeorm_1.OneToOne(function (type) { return address_type_1.Address; }, { nullable: false, cascade: true }),
        typeorm_1.JoinColumn(),
        __metadata("design:type", address_type_1.Address)
    ], Farm.prototype, "address", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.OneToMany(function (type) { return agreement_type_1.Agreement; }, function (agreement) { return agreement.farm; }, { nullable: true }),
        __metadata("design:type", Array)
    ], Farm.prototype, "agreements", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.OneToMany(function (type) { return userFarmer_type_1.UserFarmer; }, function (userFarmer) { return userFarmer.farm; }, { nullable: true }),
        __metadata("design:type", Array)
    ], Farm.prototype, "farmers", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.ManyToMany(function (type) { return userConsultant_type_1.UserConsultant; }, function (userConsultant) { return userConsultant.farms; }, { nullable: true }),
        typeorm_1.JoinTable({ name: 'farm_consultant' }),
        __metadata("design:type", Array)
    ], Farm.prototype, "consultants", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.ManyToOne(function (type) { return dairyCompany_type_1.DairyCompany; }, function (dairyCompany) { return dairyCompany.farms; }, { nullable: true }),
        __metadata("design:type", dairyCompany_type_1.DairyCompany)
    ], Farm.prototype, "dairyCompany", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.OneToMany(function (type) { return expense_type_1.Expense; }, function (expense) { return expense.farm; }, { nullable: true }),
        __metadata("design:type", Array)
    ], Farm.prototype, "expenses", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.OneToMany(function (type) { return inventoryItem_type_1.InventoryItem; }, function (inventoryItem) { return inventoryItem.farm; }, { nullable: true }),
        __metadata("design:type", Array)
    ], Farm.prototype, "inventoryItems", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.OneToMany(function (type) { return animal_type_1.Animal; }, function (animal) { return animal.farm; }, { nullable: true }),
        __metadata("design:type", Array)
    ], Farm.prototype, "animals", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.OneToMany(function (type) { return revenue_type_1.Revenue; }, function (revenue) { return revenue.farm; }, { nullable: false }),
        __metadata("design:type", Array)
    ], Farm.prototype, "revenues", void 0);
    Farm = __decorate([
        typeorm_1.Entity()
    ], Farm);
    return Farm;
}(basicR_type_1.BasicREntity));
exports.Farm = Farm;
//# sourceMappingURL=farm.type.js.map