"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var farm_type_1 = require("./farm.type");
var typeorm_1 = require("typeorm");
var basicR_type_1 = require("../basicR.type");
var class_validator_1 = require("class-validator");
var user_type_1 = require("../app/user.type");
var visit_type_1 = require("./visit.type");
var ConsultantRole;
(function (ConsultantRole) {
    ConsultantRole[ConsultantRole["CONSULTANT"] = 1] = "CONSULTANT";
    ConsultantRole[ConsultantRole["CONSULTANT_AUX"] = 2] = "CONSULTANT_AUX";
})(ConsultantRole = exports.ConsultantRole || (exports.ConsultantRole = {}));
var UserConsultant = /** @class */ (function (_super) {
    __extends(UserConsultant, _super);
    function UserConsultant() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UserConsultant_1 = UserConsultant;
    var UserConsultant_1;
    __decorate([
        class_validator_1.IsNotEmpty(),
        typeorm_1.ManyToOne(function (type) { return user_type_1.User; }, function (user) { return user.userConsultant; }, { nullable: false }),
        __metadata("design:type", user_type_1.User)
    ], UserConsultant.prototype, "user", void 0);
    __decorate([
        class_validator_1.IsNumber(),
        typeorm_1.Column({ nullable: false, type: 'int' }),
        __metadata("design:type", Number)
    ], UserConsultant.prototype, "role", void 0);
    __decorate([
        class_validator_1.IsString(),
        class_validator_1.IsOptional(),
        typeorm_1.Column({ nullable: true }),
        __metadata("design:type", String)
    ], UserConsultant.prototype, "school", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.ManyToOne(function (type) { return UserConsultant_1; }, function (userConsultant) { return userConsultant.supervisor; }, { nullable: true }),
        __metadata("design:type", UserConsultant)
    ], UserConsultant.prototype, "supervisor", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.ManyToMany(function (type) { return farm_type_1.Farm; }, function (farm) { return farm.consultants; }, { nullable: true }),
        __metadata("design:type", Array)
    ], UserConsultant.prototype, "farms", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsArray(),
        typeorm_1.OneToMany(function (type) { return visit_type_1.Visit; }, function (visit) { return visit.consultant; }, { nullable: true }),
        __metadata("design:type", Array)
    ], UserConsultant.prototype, "visits", void 0);
    UserConsultant = UserConsultant_1 = __decorate([
        typeorm_1.Entity()
    ], UserConsultant);
    return UserConsultant;
}(basicR_type_1.BasicREntity));
exports.UserConsultant = UserConsultant;
//# sourceMappingURL=userConsultant.type.js.map