"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var basicR_type_1 = require("../basicR.type");
var typeorm_1 = require("typeorm");
var farm_type_1 = require("../visit/farm.type");
var animalEvent_type_1 = require("./animalEvent.type");
var class_validator_1 = require("class-validator");
var RaceType;
(function (RaceType) {
    RaceType[RaceType["HOLSTEIN"] = 0] = "HOLSTEIN";
    RaceType[RaceType["GIR"] = 1] = "GIR";
})(RaceType = exports.RaceType || (exports.RaceType = {}));
var Animal = /** @class */ (function (_super) {
    __extends(Animal, _super);
    function Animal() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Animal_1 = Animal;
    var Animal_1;
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsString(),
        typeorm_1.Column({ nullable: true }),
        __metadata("design:type", String)
    ], Animal.prototype, "earring", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsNotEmpty(),
        class_validator_1.IsNumber(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", Number)
    ], Animal.prototype, "status", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsNotEmpty(),
        class_validator_1.IsString(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", String)
    ], Animal.prototype, "name", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.Column({ nullable: true }),
        __metadata("design:type", String)
    ], Animal.prototype, "nickname", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsString(),
        typeorm_1.Column({ nullable: true }),
        __metadata("design:type", String)
    ], Animal.prototype, "origin", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsNotEmpty(),
        class_validator_1.IsDate(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", Date)
    ], Animal.prototype, "dateOfBirth", void 0);
    __decorate([
        class_validator_1.IsNotEmpty(),
        class_validator_1.IsNumber(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", Number)
    ], Animal.prototype, "numberOfChildBirths", void 0);
    __decorate([
        typeorm_1.Column({ nullable: false, type: 'int' }),
        __metadata("design:type", Number)
    ], Animal.prototype, "sex", void 0);
    __decorate([
        class_validator_1.IsNotEmpty(),
        class_validator_1.IsDate(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", Date)
    ], Animal.prototype, "dateOfRemovalOfHorns", void 0);
    __decorate([
        class_validator_1.IsNotEmpty(),
        class_validator_1.IsDate(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", Date)
    ], Animal.prototype, "dateOfWeaning", void 0);
    __decorate([
        class_validator_1.IsNotEmpty(),
        class_validator_1.IsDate(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", Date)
    ], Animal.prototype, "dataAptitude", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.Column({ nullable: true }),
        __metadata("design:type", Date)
    ], Animal.prototype, "dateOfDeath", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsString(),
        typeorm_1.Column({ nullable: true }),
        __metadata("design:type", String)
    ], Animal.prototype, "reasonOfDeath", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsString(),
        typeorm_1.Column({ nullable: true }),
        __metadata("design:type", String)
    ], Animal.prototype, "rfid", void 0);
    __decorate([
        class_validator_1.IsNotEmpty(),
        class_validator_1.IsNumber(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", Number)
    ], Animal.prototype, "class", void 0);
    __decorate([
        class_validator_1.IsNumber(),
        typeorm_1.Column({ nullable: false, type: 'int' }),
        __metadata("design:type", Number)
    ], Animal.prototype, "race", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.OneToOne(function (type) { return animalEvent_type_1.AnimalEvent; }, { nullable: true }),
        typeorm_1.JoinColumn(),
        __metadata("design:type", animalEvent_type_1.AnimalEvent)
    ], Animal.prototype, "reproductiveEvent", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.ManyToOne(function (type) { return farm_type_1.Farm; }, function (farm) { return farm.animals; }, { nullable: true }),
        __metadata("design:type", farm_type_1.Farm)
    ], Animal.prototype, "farm", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.OneToOne(function (type) { return Animal_1; }, { nullable: true }),
        typeorm_1.JoinColumn(),
        __metadata("design:type", Animal)
    ], Animal.prototype, "mother", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.OneToOne(function (type) { return Animal_1; }, { nullable: true }),
        typeorm_1.JoinColumn(),
        __metadata("design:type", Animal)
    ], Animal.prototype, "biologicalMother", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.OneToOne(function (type) { return Animal_1; }, { nullable: true }),
        typeorm_1.JoinColumn(),
        __metadata("design:type", Animal)
    ], Animal.prototype, "biologicalFather", void 0);
    Animal = Animal_1 = __decorate([
        typeorm_1.Entity()
    ], Animal);
    return Animal;
}(basicR_type_1.BasicREntity));
exports.Animal = Animal;
//# sourceMappingURL=animal.type.js.map