"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var basicR_type_1 = require("../basicR.type");
var typeorm_1 = require("typeorm");
var animal_type_1 = require("./animal.type");
var class_validator_1 = require("class-validator");
var ReproductiveEvent;
(function (ReproductiveEvent) {
    ReproductiveEvent[ReproductiveEvent["IMPREGNATION"] = 0] = "IMPREGNATION";
    ReproductiveEvent[ReproductiveEvent["OBSERVED_HEAT"] = 1] = "OBSERVED_HEAT";
    ReproductiveEvent[ReproductiveEvent["FOLICULAR_ASPIRATION"] = 2] = "FOLICULAR_ASPIRATION";
    ReproductiveEvent[ReproductiveEvent["EMBRIO_COLLECT"] = 3] = "EMBRIO_COLLECT";
    ReproductiveEvent[ReproductiveEvent["EMBRIO_TRANSFER"] = 4] = "EMBRIO_TRANSFER";
    ReproductiveEvent[ReproductiveEvent["CONVENTIONAL_SEMEN"] = 5] = "CONVENTIONAL_SEMEN";
    ReproductiveEvent[ReproductiveEvent["SEXED_SEMEN"] = 6] = "SEXED_SEMEN";
    ReproductiveEvent[ReproductiveEvent["IN_VITRO_FERTILIZATION"] = 7] = "IN_VITRO_FERTILIZATION";
    ReproductiveEvent[ReproductiveEvent["REPRODUCTIVE_OCCURENCE"] = 8] = "REPRODUCTIVE_OCCURENCE";
    ReproductiveEvent[ReproductiveEvent["EMBRIO_ABSORBTION"] = 9] = "EMBRIO_ABSORBTION";
    ReproductiveEvent[ReproductiveEvent["ABORTION_WITHOUT_LACTATION"] = 10] = "ABORTION_WITHOUT_LACTATION";
    ReproductiveEvent[ReproductiveEvent["MALE_BIRTH"] = 11] = "MALE_BIRTH";
    ReproductiveEvent[ReproductiveEvent["FEMALE_BIRTH"] = 12] = "FEMALE_BIRTH";
    ReproductiveEvent[ReproductiveEvent["MALE_MALE_BIRTH"] = 13] = "MALE_MALE_BIRTH";
    ReproductiveEvent[ReproductiveEvent["MALE_FEMALE_BIRTH"] = 14] = "MALE_FEMALE_BIRTH";
    ReproductiveEvent[ReproductiveEvent["FEMALE_FEMALE_BIRTH"] = 15] = "FEMALE_FEMALE_BIRTH";
    ReproductiveEvent[ReproductiveEvent["ABORTION_WITH_LACTATION"] = 16] = "ABORTION_WITH_LACTATION";
    ReproductiveEvent[ReproductiveEvent["STILLBIRTH"] = 17] = "STILLBIRTH";
    ReproductiveEvent[ReproductiveEvent["POSITIVE_GESTATION_DIAGNOSIS"] = 18] = "POSITIVE_GESTATION_DIAGNOSIS";
    ReproductiveEvent[ReproductiveEvent["NEGATIVE_GESTATION_DIAGNOSIS"] = 19] = "NEGATIVE_GESTATION_DIAGNOSIS";
    ReproductiveEvent[ReproductiveEvent["BIRTH_NOT_REGISTERED_IN_APP"] = 20] = "BIRTH_NOT_REGISTERED_IN_APP";
})(ReproductiveEvent = exports.ReproductiveEvent || (exports.ReproductiveEvent = {}));
var AnimalEvent = /** @class */ (function (_super) {
    __extends(AnimalEvent, _super);
    function AnimalEvent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        class_validator_1.IsNotEmpty(),
        typeorm_1.OneToOne(function (type) { return animal_type_1.Animal; }, { nullable: false }),
        typeorm_1.JoinColumn(),
        __metadata("design:type", animal_type_1.Animal)
    ], AnimalEvent.prototype, "animal", void 0);
    __decorate([
        class_validator_1.IsNumber(),
        typeorm_1.Column({ nullable: false, type: 'int' }),
        __metadata("design:type", Number)
    ], AnimalEvent.prototype, "reproductiveEvent", void 0);
    __decorate([
        class_validator_1.IsNotEmpty(),
        class_validator_1.IsDate(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", Date)
    ], AnimalEvent.prototype, "eventDate", void 0);
    __decorate([
        class_validator_1.IsNotEmpty(),
        class_validator_1.IsNumber(),
        typeorm_1.Column({ nullable: false }),
        __metadata("design:type", Number)
    ], AnimalEvent.prototype, "cicle", void 0);
    __decorate([
        class_validator_1.IsBoolean(),
        typeorm_1.Column({ nullable: false, default: false }),
        __metadata("design:type", Boolean)
    ], AnimalEvent.prototype, "cicleClosure", void 0);
    AnimalEvent = __decorate([
        typeorm_1.Entity()
    ], AnimalEvent);
    return AnimalEvent;
}(basicR_type_1.BasicREntity));
exports.AnimalEvent = AnimalEvent;
//# sourceMappingURL=animalEvent.type.js.map