import { Connection, DeepPartial, Repository } from 'typeorm';
import { JoinFilter, HavingFilter, OrderByAction, LimitOffsetAction } from '../utils/query.utils';
import { BasicREntity } from '../entities/basicR.type';
import { QueryDeepPartialEntity } from 'typeorm/query-builder/QueryPartialEntity';
export declare abstract class BasicRDAO<T extends BasicREntity> {
    protected abstract getDatabase(): any;
    protected abstract getTableName(): string;
    private database;
    private connection;
    protected getRepository(connection: Connection): Repository<T>;
    getConnection(): Connection;
    findByFilter(joinFilters?: JoinFilter[], havingFilters?: HavingFilter[], orderByActions?: OrderByAction[], limitOffsetAction?: LimitOffsetAction, full?: boolean): Promise<Array<T>>;
    drop(): Promise<void>;
    count(joinFilters?: JoinFilter[], havingFilters?: HavingFilter[], orderByActions?: OrderByAction[], limitOffsetAction?: LimitOffsetAction): Promise<number>;
    getByFilter(joinFilters?: JoinFilter[], havingFilters?: HavingFilter[], orderByActions?: OrderByAction[], limitOffsetAction?: LimitOffsetAction, full?: boolean): Promise<T | undefined>;
    get(id: number): Promise<T | undefined>;
    save(entity: DeepPartial<T>): Promise<string>;
    update(entity: QueryDeepPartialEntity<T>, id: number): Promise<void>;
    remove(id: number): Promise<void>;
}
