"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var query_utils_1 = require("../utils/query.utils");
var BasicRDAO = /** @class */ (function () {
    function BasicRDAO() {
        this.database = this.getDatabase();
    }
    BasicRDAO.prototype.getRepository = function (connection) {
        this.connection = connection;
        return connection.getRepository(this.getTableName());
    };
    BasicRDAO.prototype.getConnection = function () {
        return this.connection;
    };
    BasicRDAO.prototype.findByFilter = function (joinFilters, havingFilters, orderByActions, limitOffsetAction, full) {
        return __awaiter(this, void 0, void 0, function () {
            var qb, _a, entities_1, entities, ex_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        console.debug("BasicService.findByFilter.");
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 6, , 7]);
                        _a = this.getRepository;
                        return [4 /*yield*/, this.database.getConnection()];
                    case 2:
                        qb = _a.apply(this, [_b.sent()]).createQueryBuilder(this.getTableName());
                        query_utils_1.QueryUtils.defineFilters(qb, joinFilters, orderByActions, limitOffsetAction, havingFilters);
                        console.debug(qb.getSql());
                        if (!full) return [3 /*break*/, 4];
                        return [4 /*yield*/, qb.loadAllRelationIds().getMany()];
                    case 3:
                        entities_1 = _b.sent();
                        return [2 /*return*/, Promise.resolve(!Array.isArray(entities_1) ? [] : entities_1)];
                    case 4: return [4 /*yield*/, qb.getMany()];
                    case 5:
                        entities = _b.sent();
                        return [2 /*return*/, Promise.resolve(!Array.isArray(entities) ? [] : entities)];
                    case 6:
                        ex_1 = _b.sent();
                        console.error(ex_1);
                        return [2 /*return*/, Promise.reject(ex_1)];
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    BasicRDAO.prototype.drop = function () {
        return __awaiter(this, void 0, void 0, function () {
            var qb, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.getRepository;
                        return [4 /*yield*/, this.database.getConnection()];
                    case 1:
                        qb = _a.apply(this, [_b.sent()]);
                        qb.query("DELETE FROM `" + this.getTableName() + "`;");
                        return [2 /*return*/];
                }
            });
        });
    };
    BasicRDAO.prototype.count = function (joinFilters, havingFilters, orderByActions, limitOffsetAction) {
        return __awaiter(this, void 0, void 0, function () {
            var qb, _a, count, ex_2;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        console.debug("BasicService.count.");
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 4, , 5]);
                        _a = this.getRepository;
                        return [4 /*yield*/, this.database.getConnection()];
                    case 2:
                        qb = _a.apply(this, [_b.sent()]).createQueryBuilder(this.getTableName());
                        query_utils_1.QueryUtils.defineFilters(qb, joinFilters, orderByActions, limitOffsetAction, havingFilters);
                        console.debug(qb.getSql());
                        return [4 /*yield*/, qb.getCount()];
                    case 3:
                        count = _b.sent();
                        return [2 /*return*/, Promise.resolve(count)];
                    case 4:
                        ex_2 = _b.sent();
                        console.error(ex_2);
                        return [2 /*return*/, Promise.reject(ex_2)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    BasicRDAO.prototype.getByFilter = function (joinFilters, havingFilters, orderByActions, limitOffsetAction, full) {
        return __awaiter(this, void 0, void 0, function () {
            var qb, _a, entity_1, entity, ex_3;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        console.debug("BasicService.getByFilter.");
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 6, , 7]);
                        _a = this.getRepository;
                        return [4 /*yield*/, this.database.getConnection()];
                    case 2:
                        qb = _a.apply(this, [_b.sent()]).createQueryBuilder(this.getTableName());
                        query_utils_1.QueryUtils.defineFilters(qb, joinFilters, orderByActions, limitOffsetAction, havingFilters);
                        console.debug(qb.getSql());
                        if (!full) return [3 /*break*/, 4];
                        return [4 /*yield*/, qb.loadAllRelationIds().getOne()];
                    case 3:
                        entity_1 = _b.sent();
                        return [2 /*return*/, Promise.resolve(entity_1)];
                    case 4: return [4 /*yield*/, qb.getOne()];
                    case 5:
                        entity = _b.sent();
                        return [2 /*return*/, Promise.resolve(entity)];
                    case 6:
                        ex_3 = _b.sent();
                        console.error(ex_3);
                        return [2 /*return*/, Promise.reject(ex_3)];
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    BasicRDAO.prototype.get = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var havingFilters;
            return __generator(this, function (_a) {
                havingFilters = Array();
                havingFilters.push(new query_utils_1.HavingFilter(this.getTableName() + '.id = ' + '"' + id + '"', undefined, true));
                return [2 /*return*/, this.getByFilter(undefined, havingFilters, undefined, undefined, true)];
            });
        });
    };
    BasicRDAO.prototype.save = function (entity) {
        return __awaiter(this, void 0, void 0, function () {
            var newEntity, _a, ex_4;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        console.debug("BasicService.save. Value: " + JSON.stringify(entity));
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 4, , 5]);
                        _a = this.getRepository;
                        return [4 /*yield*/, this.database.getConnection()];
                    case 2: return [4 /*yield*/, _a.apply(this, [_b.sent()]).save(entity)];
                    case 3:
                        newEntity = _b.sent();
                        return [2 /*return*/, Promise.resolve(newEntity.id)];
                    case 4:
                        ex_4 = _b.sent();
                        console.error(ex_4);
                        return [2 /*return*/, Promise.reject(ex_4)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    BasicRDAO.prototype.update = function (entity, id) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, ex_5;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        console.debug("BasicService.update. Value: " + JSON.stringify(entity));
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 4, , 5]);
                        _a = this.getRepository;
                        return [4 /*yield*/, this.database.getConnection()];
                    case 2: 
                    // entity.id = id;
                    return [4 /*yield*/, _a.apply(this, [_b.sent()]).update(id, entity)];
                    case 3:
                        // entity.id = id;
                        _b.sent();
                        return [2 /*return*/, Promise.resolve()];
                    case 4:
                        ex_5 = _b.sent();
                        console.error(ex_5);
                        return [2 /*return*/, Promise.reject(ex_5)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    BasicRDAO.prototype.remove = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, ex_6;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        console.debug("BasicService.remove. Value: " + JSON.stringify(id));
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 4, , 5]);
                        _a = this.getRepository;
                        return [4 /*yield*/, this.database.getConnection()];
                    case 2: return [4 /*yield*/, _a.apply(this, [_b.sent()]).delete(id)];
                    case 3:
                        _b.sent();
                        return [2 /*return*/, Promise.resolve()];
                    case 4:
                        ex_6 = _b.sent();
                        console.error(ex_6);
                        return [2 /*return*/, Promise.reject(ex_6)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    return BasicRDAO;
}());
exports.BasicRDAO = BasicRDAO;
//# sourceMappingURL=basicR.dao.js.map