import { SelectQueryBuilder } from 'typeorm/query-builder/SelectQueryBuilder';
export declare enum JoinType {
    LeftJoinAndSelect = 0,
    LeftJoin = 1,
    InnerJoin = 2,
    InnerJoinAndSelect = 3
}
export declare class QueryFilters {
    constructor(joinFilters: JoinFilter[], havingFilters: HavingFilter[]);
    joinFilters: JoinFilter[];
    havingFilters: HavingFilter[];
}
export declare class OrderByAction {
    constructor(property: string, type: 'ASC' | 'DESC');
    property: string;
    type: 'ASC' | 'DESC';
}
export declare class LimitOffsetAction {
    constructor(limit?: number, offset?: number);
    limit?: number;
    offset?: number;
}
export declare class Parameter {
    constructor(key: string, value: any);
    key: string;
    value: string;
}
export declare class JoinFilter {
    constructor(property: string, alias: string, condition?: string, parameters?: Parameter[], joinType?: JoinType);
    property: string;
    alias: string;
    condition?: string;
    parameters?: Parameter[];
    joinType?: JoinType;
}
export declare class HavingFilter {
    constructor(having: string, parameters?: Parameter[], inclusive?: boolean, select?: boolean);
    having: string;
    parameters?: Parameter[];
    inclusive: boolean;
    select: boolean;
}
export declare class QueryUtils {
    static defineFilters(qb: SelectQueryBuilder<any>, joinFilters?: JoinFilter[], orderByActions?: OrderByAction[], limitOffsetAction?: LimitOffsetAction, havingFilters?: HavingFilter[]): void;
}
