"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var class_validator_1 = require("class-validator");
function IsBiggerThan(property, validationOptions) {
    return function (object, propertyName) {
        class_validator_1.registerDecorator({
            name: "IsBiggerThan",
            target: object.constructor,
            propertyName: propertyName,
            constraints: [property],
            options: validationOptions,
            validator: {
                validate: function (value, args) {
                    var relatedPropertyName = args.constraints[0];
                    var relatedValue = args.object[relatedPropertyName];
                    if (typeof value === 'string') {
                        value = new Date(value);
                    }
                    if (typeof relatedValue === 'string') {
                        relatedValue = new Date(relatedValue);
                    }
                    return value.getTime() > relatedValue.getTime();
                }
            }
        });
    };
}
exports.IsBiggerThan = IsBiggerThan;
//# sourceMappingURL=isBiggerThan.validator.js.map