import { City } from './city.type';
import { Entity, Column, OneToOne, JoinColumn, ManyToOne, OneToMany } from 'typeorm';
import { BasicREntity } from '../basicR.type';
import { IsNumber, IsString, IsDefined, IsOptional } from 'class-validator';

@Entity()
export class Address extends BasicREntity {
  
  @IsString()
  @Column({ nullable: false })
  place: string;

  @IsOptional()
  @IsNumber()
  @Column({ nullable: true })
  lat?: number;

  @IsOptional()
  @IsNumber()
  @Column({ nullable: true })
  lon?: number;

  @IsOptional()
  @IsString()
  @Column({ nullable: true })
  zipCode?: string;

  @IsOptional()
  @ManyToOne(type => City, { nullable: true })
  city?: City;
}