import { Address } from './address.type';
import { Entity, Column, OneToOne, JoinColumn, ManyToOne, OneToMany } from 'typeorm';
import { BasicREntity } from '../basicR.type';
import { IsString, IsNotEmpty, IsOptional } from 'class-validator';
import { State } from './state.type'

@Entity()
export class City extends BasicREntity {

  @IsString()
  @IsNotEmpty()
  @Column({ nullable: false })
  name: string;

  @IsNotEmpty()
  @ManyToOne(type => State, state => state.cities, { nullable: false })
  state: State;
}