import { Entity, Column, JoinColumn, PrimaryGeneratedColumn, OneToMany } from 'typeorm';
import { BasicREntity } from '../basicR.type';
import { IsString, IsNotEmpty, IsOptional } from 'class-validator';
import { State } from './state.type';

@Entity()
export class Country extends BasicREntity {

  @IsString()
  @IsNotEmpty()
  @Column({ nullable: false })
  name: string;

  @IsString()
  @IsNotEmpty()
  @Column({ nullable: false })
  initials: string;

  @IsOptional()
  @OneToMany(type => State, state => state.country, { nullable: true })
  states?: State[];

}