import { Entity, Column, ManyToOne, OneToMany, OneToOne, JoinColumn } from 'typeorm';
import { BasicREntity } from '../basicR.type';
import { IsString, IsNotEmpty, IsOptional } from 'class-validator';
import { Country } from './country.type';
import { City } from './city.type';

@Entity()
export class State extends BasicREntity {

  @IsString()
  @IsNotEmpty()
  @Column({ nullable: false })
  name: string;

  @IsString()
  @IsNotEmpty()
  @Column({ nullable: false })
  initials: string;

  @IsNotEmpty()
  @ManyToOne(type => Country, country => country.states, { nullable: false })
  country: Country;

  @IsOptional()
  @OneToMany(type => City, city => city.state, { nullable: true })
  cities?: City[];

}