import { PrimaryGeneratedColumn, CreateDateColumn, UpdateDateColumn, VersionColumn, Column } from 'typeorm';

export class BasicREntity {
  @PrimaryGeneratedColumn('uuid')
  id: string;

  @CreateDateColumn()
  createDate: Date;

  @UpdateDateColumn({nullable: true})
  updateDate?: Date;

  @VersionColumn()
  version: number;

  @Column({ default: true })
  active: boolean;

  @Column({ default: false })
  deleted: boolean;

  @Column({ default: true })
  insync: boolean;
}