import { Entity, Column, JoinColumn, PrimaryGeneratedColumn, OneToOne, OneToMany, ManyToOne } from 'typeorm';
import { BasicREntity } from '../basicR.type';
import { IsNumber, IsDate, IsNotEmpty } from 'class-validator';
import { Farm } from '../visit/farm.type'

export enum ExpenseCategory {
  OTHER,
  HIRED_WORKER,
  CONCENTRATED,
  NUCLEI_AND_MINERALS,
  LOAN_PAYMENT

// Ordem de produção - Milho Rehidratado
// Ordem de produção - Silagem de Milho (Volumoso)
// Ordem de produção - Manutenção de Pastagem (Volumoso)

}

@Entity()
export class Expense extends BasicREntity {
  
  @IsDate()
  @IsNotEmpty()
  @Column({ nullable: false })
  date: Date;

  @IsNotEmpty()
  @ManyToOne(type => Farm, farm => farm.expenses, { nullable: true })
  farm: Farm;

}