import { IsDate, IsNumber, IsNotEmpty } from 'class-validator';
import { Column, Entity, ManyToOne, OneToOne, JoinColumn } from 'typeorm';
import { BasicREntity } from '../basicR.type';
import { Loan } from './loan.type';

@Entity()
export class Installment extends BasicREntity {
  
  @IsDate()
  @IsNotEmpty()
  @Column({ nullable: false })
  date: Date;

  @IsNumber()
  @IsNotEmpty()
  @Column({ nullable: false })
  value: number;

  @IsNotEmpty()
  @ManyToOne(type => Loan, loan => loan.installments, { nullable: true })
  loan: Loan;
}