import { Entity, Column, ManyToOne, JoinColumn, OneToMany, JoinTable } from 'typeorm';
import { BasicREntity } from '../basicR.type';
import { IsString, IsNotEmpty, IsOptional } from 'class-validator';

@Entity()
export class Consulting extends BasicREntity {

    @IsString()
    @IsNotEmpty()
    @Column({ nullable: false })
    name: string;

    @IsOptional()
    @IsString()
    @Column({ nullable: true })
    identification?: string;
}