import { Entity, Column, JoinColumn, PrimaryGeneratedColumn, OneToMany, ManyToOne, OneToOne, ManyToMany } from 'typeorm';
import { BasicREntity } from '../basicR.type';
import { IsNumber, IsNotEmpty, IsOptional, IsArray } from 'class-validator';
import { User } from '../app/user.type';
import { Farm } from './farm.type';
import { Visit } from './visit.type';

export enum FarmRole {
    OWNER = 1,
    WORKER = 2
}

@Entity()
export class UserFarmer extends BasicREntity {

    @IsNotEmpty()
    @ManyToOne(type => User, user => user.userFarmer, { nullable: false })
    user: User;

    @IsNotEmpty()
    @ManyToOne(type => Farm, farm => farm.farmers, { nullable: false })
    farm: Farm;

    @IsNumber()
    @Column({ nullable: false, type: 'int' })
    role: FarmRole;
}