import { Entity, Column, JoinColumn, PrimaryGeneratedColumn, OneToMany, OneToOne, ManyToOne } from 'typeorm';
import { BasicREntity } from '../basicR.type';
import { Agreement } from './agreement.type';
import { IsDate, IsNotEmpty } from 'class-validator';
import { UserConsultant } from './userConsultant.type';

@Entity()
export class Visit extends BasicREntity {

  @IsNotEmpty()
  @ManyToOne(type => UserConsultant, userConsultant => userConsultant.visits, { nullable: false })
  consultant: UserConsultant;
 
  @IsNotEmpty()
  @ManyToOne(type => Agreement, agreement => agreement.visits, { nullable: false })
  agreement: Agreement;

  @IsNotEmpty()
  @IsDate()
  @Column({ nullable: false })
  date: Date;
}