import { transformAndValidate } from "class-transformer-validator";
import { BasicNREntity } from "../entities/basicNR.type";

export default abstract class BasicNRDAO<T extends BasicNREntity> {

  protected abstract getCollectionName(): string;
  protected abstract getMongoObjectId(id: string);

  async all(database): Promise<Array<T>> {
    const collection = database.collection(this.getCollectionName());
    return collection.find({}).toArray();
  }

  async get(database, id: any): Promise<T> {
    // if(!_id) {
    //   return Promise.reject([ {
    //     target: [T],
    //     property: '_id'
    //   } ]);
    // }
    const collection = database.collection(this.getCollectionName());
    return collection.findOne({ '_id': this.getMongoObjectId(id) });
  }

  public static async drop(database): Promise<void> {
    // const collection = database.collection(Constants.COLLECTION_PROPERTY);
    // return collection.drop();
  }

  async save(database, entity: T): Promise<number> {
    const collection = database.collection(this.getCollectionName());
    entity.createDate = new Date();
    // const ans = await collection.insertOne(await transformAndValidate(T, entity));
    // return ans.insertedId;
    return 0;
  }

  async update(database, entity: T, id: any): Promise<void> {
    // if(!_id) {
    //   return Promise.reject([ {
    //     target: [T],
    //     property: '_id'
    //   } ]);
    // }
    const collection = database.collection(this.getCollectionName());
    entity.updateDate = new Date();
    delete entity._id;
    // await collection.update(
    //   { '_id': ObjectId(_id) },
    //   await transformAndValidate(T, entity),
    //   { upsert: true }
    // );
    entity._id = this.getMongoObjectId(id);
  }

  async remove(database, id: any): Promise<void> {
    // if(!_id) {
    //   return Promise.reject([ {
    //     target: [T],
    //     property: '_id'
    //   } ]);
    // }
    const collection = database.collection(this.getCollectionName());
    await collection.remove({ '_id': this.getMongoObjectId(id) });
  }

}
